//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  vector<int> coll1;
  vector<int> coll2;

  INSERT_ELEMENTS(coll1,1,9);
  INSERT_ELEMENTS(coll2,1,9);
  PRINT_ELEMENTS(coll1,"1- :\n");
  PRINT_ELEMENTS(coll2,"2- :\n");
  cout << endl;

  //      
  vector<int>::iterator pos1, pos2;
  pos1 = partition(coll1.begin(), coll1.end(),              // 
                   not1(bind2nd(modulus<int>(),2)));        // 
  pos2 = stable_partition(coll2.begin(), coll2.end(),       // 
                          not1(bind2nd(modulus<int>(),2))); // 

  //      
  PRINT_ELEMENTS(coll1,"1- :\n");
  cout << ToRus("  : ") << *pos1 << endl;
  PRINT_ELEMENTS(coll2,"2- :\n");
  cout << ToRus("  : ") << *pos2 << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------